## ocaml 5.4.1

=== debian/changelog ===
ocaml (5.4.1-1~exp1) experimental; urgency=medium

  * New upstream release (Closes: #1129317, CVE-2026-28364)
  * Stabilize compiler-libs ABI by not including config.cmx
  * Print .cmi flags in objinfo
  * Bump Standards-Version to 4.7.3
  * Remove Priority field from debian/control

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Mar 2026 08:28:58 +0100

ocaml (5.4.0-3) unstable; urgency=medium

  * Remove transitional packages (Closes: #1125099)
  * Clean up Breaks/Replaces fulfilled by stable
  * Remove MANIFEST and "debian/rules regenerate"
  * Fix /usr/local/lib/ocaml ownership (Closes: #982067)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 11 Feb 2026 14:40:10 +0100

ocaml (5.4.0-2) unstable; urgency=medium

  * Increase the amount of data written to a pipe in a test
    (Closes: #1107773)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 09 Jan 2026 08:54:31 +0100

ocaml (5.4.0-1) unstable; urgency=medium

  * New upstream release
    - fma test from test suite fails on hppa, enable emulation like on
      m68k
    - mark test_compact_manydomains as multicore
  * Build --without-zstd
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 26 Dec 2025 12:48:51 +0100

=== debian/control ===
Source: ocaml
Section: ocaml
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Mehdi Dogguy <mehdi@debian.org>,
 Ximin Luo <infinity0@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 binutils-dev,
 libiberty-dev,
 libncurses-dev,
 zlib1g-dev,
 dh-ocaml
Build-Conflicts: ocaml-base
Standards-Version: 4.7.3
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml
Homepage: https://ocaml.org/

# This needs to stay at the top - we symlink docs to the copy in this package,
# and dh_installdocs installs README.Debian etc into the first package listed.
Package: ocaml-base
Architecture: any
Depends:
 libstdlib-ocaml (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ocaml-base-${F:OCamlABI}
Description: Runtime system for OCaml bytecode executables
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains only the runtime system needed to run bytecode
 executables. The 'ocaml' package contains the full development suite of
 Objective Caml.

Package: ocaml
Architecture: any
Depends:
 ocaml-interp (= ${binary:Version}),
 libncurses-dev,
 gcc,
 binutils,
 libzstd-dev,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ocaml-${F:OCamlABI},
 ocaml-best-compilers (= ${binary:Version}),
 ${F:NativeProvides}
Suggests:
 ocaml-doc,
 elpa-tuareg
Recommends:
 ocaml-man,
 file
Description: ML language implementation with a class-based object system
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications.

Package: libstdlib-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 libseq-ocaml-dev,
 libuchar-ocaml-dev,
 libstdlib-shims-ocaml-dev,
 ${ocaml:Provides}
Recommends:
 ocaml-man
Description: OCaml standard library (development files)
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains the development files of the standard library.

Package: libstdlib-ocaml
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 libseq-ocaml,
 libuchar-ocaml,
 libstdlib-shims-ocaml,
 ${ocaml:Provides}
Description: OCaml standard library (runtime files)
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains the runtime files of the standard library.

Package: libcompiler-libs-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Description: OCaml compiler library (development files)
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains the development files of the compiler library.

Package: ocaml-source
Architecture: all
Depends: ${misc:Depends}
Provides: ocaml-source-${F:OCamlABI}
Description: Sources for Objective Caml
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains the sources needed to build some packages which build
 depend on the OCaml source. Notice that if you want to rebuild OCaml, these
 will not work, consider using the source package instead.

Package: ocaml-interp
Architecture: any
Depends:
 ocaml-base (= ${binary:Version}),
 libcompiler-libs-ocaml-dev (= ${binary:Version}),
 ${ocaml:Depends},
 ${misc:Depends}
Provides:
 ocaml-interp-${F:OCamlABI}
Recommends: ledit | readline-editor
Description: OCaml interactive interpreter and standard libraries
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the files required to run an OCaml shell from the
 command line.

Package: ocaml-man
Architecture: all
Depends:
 ${misc:Depends}
Description: OCaml interpreter and standard libraries (lib manpages)
 OCaml is a functional, statically-typed programming language from the ML
 family, offering a powerful module system extending that of Standard ML and
 a feature-rich, class-based object system.
 .
 This package contains ocamldoc-generated documentation about libraries
 provided by OCaml.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

PACKAGE := ocaml
ALL_PACKAGES := $(shell dh_listpackages)

# Can't use /usr/share/ocaml/ocamlvars.mk because it tries to run ocamlc
include $(CURDIR)/debian/ocamlvars.mk

# Use ccache if pkg.ocaml.ccache build-profile is active.
ifneq (,$(filter pkg.ocaml.ccache,$(DEB_BUILD_PROFILES)))
export PATH := /usr/lib/ccache:$(PATH)
export CCACHE_DIR := $(CURDIR)/debian/ccache
#export CCACHE_BASEDIR := $(CURDIR)/debian/build
$(shell mkdir -p "$(CCACHE_DIR)")
endif

# Build cache (for Debian debugging)
BUILDCACHE := $(wildcard ../ocaml.cache)

MD5SUMSDIR = /var/lib/ocaml/md5sums
INSTDIR = $(CURDIR)/debian/tmp/usr
DISTDIR = $(PACKAGE)-$(OCAML_ABI)
UPSTREAM_VERSION = $(shell dpkg-parsechangelog | awk '/^Version:/{print $$2}' | { read u; echo $${u%-*}; })
UPSTREAM_TARBALL = $(wildcard ../$(PACKAGE)_$(UPSTREAM_VERSION).orig.tar.*)
SRCTARBALL = $(PACKAGE)-source-$(OCAML_ABI).tar

TESTDIR := debian/test-build
TESTRULES := debian/rules DEB_TEST_BUILD_PREFIX=$(CURDIR)/$(TESTDIR)

BUILD_DATE := $(shell dpkg-parsechangelog --show-field=Date)

ifeq (,$(DEB_TEST_BUILD_PREFIX))
ifneq (,$(findstring ocaml-source,$(ALL_PACKAGES)))
  TARBALL_TARGET = debian/$(SRCTARBALL)
endif
endif

# Environment variable for dh_ocaml
export OCAMLOBJINFO = OCAMLLIB=tools boot/ocamlrun tools/ocamlobjinfo

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

# This has to be exported to make dispatch work
export OCAML_OPT_ARCH
export OCAML_STDLIB_DIR

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
export CCLINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

CONFIGURE_OPTS := \
  --without-zstd \
  --enable-ocamltest \
  --host $(DEB_BUILD_GNU_TYPE)\
  -prefix $(DEB_TEST_BUILD_PREFIX)/usr \
  -libdir $(DEB_TEST_BUILD_PREFIX)$(OCAML_STDLIB_DIR) \
  -mandir $(DEB_TEST_BUILD_PREFIX)/usr/share/man \

# Upstream recommends dropping support on armel, see https://github.com/ocaml/ocaml/issues/7642
# Binaries generated by ocamlopt segfault on x32
# ld reports spurious messages on powerpc, see https://github.com/ocaml/ocaml/issues/8846
ifeq (,$(OCAML_OPT_ARCH))
CONFIGURE_OPTS += --disable-native-compiler
endif

# fma does not work on m68k, enable emulation as instructed by configure script
ifeq (m68k,$(DEB_BUILD_ARCH))
CONFIGURE_OPTS += --enable-imprecise-c99-float-ops
IGNORE_TESTS_FAILURE := || true
# fma test from test suite fails on hppa, enable emulation like on m68k
else ifeq (hppa,$(DEB_BUILD_ARCH))
CONFIGURE_OPTS += --enable-imprecise-c99-float-ops
IGNORE_TESTS_FAILURE := || true
else ifneq (,$(findstring hurd,$(DEB_BUILD_ARCH)))
IGNORE_TESTS_FAILURE := || true
else
IGNORE_TESTS_FAILURE :=
endif

# To avoid Lintian's file-references-package-build-path
export BUILD_PATH_PREFIX_MAP=.=$(CURDIR)

%:
	dh $@

# Needed because there is a "build" in the upstream tarball
.PHONY: build
build:
	dh $@

pre-config-stamp: $(TARBALL_TARGET)
# Backup upstream config.{sub,guess}, and use most up-to-date ones
	set -e; for ext in sub guess; do \
	  if [ -f /usr/share/misc/config.$$ext ] && \
	    ! [ -f debian/config.orig.$$ext ]; then \
	    mv build-aux/config.$$ext debian/config.orig.$$ext; \
	    cp -f /usr/share/misc/config.$$ext build-aux/config.$$ext; \
	  fi; \
	done
# Debian kfreebsd has non-working shims for dup3/pipe2, see #827935. Upstream
# ./configure isn't sophisticated enough to detect this so patch it out here.
ifeq (kfreebsd,$(DEB_HOST_ARCH_OS))
	sed -i -e '/HAS_DUP3/d' -e '/HAS_PIPE2/d' ./configure
endif
	touch $@

ifneq (,$(TARBALL_TARGET))
$(TARBALL_TARGET): $(UPSTREAM_TARBALL)
	mkdir -p debian/$(DISTDIR)
# Copy upstream tarball
	cp $< debian/$(DISTDIR)
# Copy debian/patches
	cp -a debian/patches debian/$(DISTDIR)/debian-patches
# Set permissions (workaround for #796257)
	chmod 755 debian/$(DISTDIR)/debian-patches
	chmod 644 debian/$(DISTDIR)/debian-patches/*
# Create the tarball and cleanup
	cd debian && find $(DISTDIR) -not -type d -print0 | \
		LC_ALL=C sort --zero-terminated | \
		tar --create --null --files-from=- \
			--file=$(abspath $@) --mtime="$(BUILD_DATE)" \
			--owner=root --group=root --numeric-owner
	rm -Rf debian/$(DISTDIR)
endif

.PHONY: override_dh_auto_configure
override_dh_auto_configure: config-stamp ocamlinit-stamp

config-stamp: pre-config-stamp
	./configure $(CONFIGURE_OPTS)
	sed -r -i '/^CFLAGS/s/-f(file|debug)-prefix-map=[^ ]* //g' Makefile.config
	touch $@

ocamlinit-stamp: $(TARBALL_TARGET) config-stamp
	$(MAKE) -f $(CURDIR)/debian/ocamlinit.mk ocamlinit-stamp

.PHONY: override_dh_auto_build
override_dh_auto_build: build-stamp

build-stamp: config-stamp
	if test ! -d boot.debian; then \
	  cp -xa boot boot.debian; \
	fi
ifeq ($(BUILDCACHE),)
	$(MAKE) world
	$(MAKE) -C tools dumpobj
ifneq (,$(OCAML_OPT_ARCH))
	@echo "Building native compilers"
	$(MAKE) opt opt.opt
	touch opt-built-stamp
endif
	@echo "Building manpages"
	$(MAKE) manpages
else
	@echo "===> WARNING: $(BUILDCACHE) detected, compilation skipped! <==="
	rsync -a --exclude=debian --exclude=.git $(BUILDCACHE)/ .
	rm -f build-stamp install-stamp*
endif
	touch $@

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
ifneq ($(wildcard $(CURDIR)/Makefile.config),)
	$(MAKE) clean
endif
	$(MAKE) -f $(CURDIR)/debian/ocamlinit.mk ocamlinit-clean
# Restore files altered by the build process
	if test -d boot.debian; then \
	  rm -Rf boot; \
	  mv boot.debian boot; \
	fi
	set -e; for ext in sub guess; do \
	  if [ -f debian/config.orig.$$ext ] ; then \
	    mv -f debian/config.orig.$$ext build-aux/config.$$ext; \
	  fi; \
	done
# Remaining stuff
	-rm -Rf debian/$(SRCTARBALL) $(TESTDIR)

execute_after_dh_clean:
	rm -f install-stamp-*
	rm -f debian/installed-files debian/*.install

.PHONY: override_dh_auto_install-arch override_dh_auto_install-indep
override_dh_auto_install-arch: install-stamp-arch
override_dh_auto_install-indep: install-stamp-indep

install-stamp-indep: install-stamp
	touch $@

install-stamp-arch: install-stamp
# Install additional files not handled by dh_install
# Beware: dh_install does not handle renamings, please pay attention
	set -e; for u in dumpobj; do \
	  if [ -f tools/$$u ]; then \
	    cp tools/$$u debian/ocaml/usr/bin/ocaml$$u; \
	  fi \
	done
# Install the seq compatibility package (OCaml >= 4.07)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/seq
	cp debian/META.seq debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/seq/META
# Install the uchar compatibility package (OCaml >= 4.03)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/uchar
	cp debian/META.uchar debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/uchar/META
# Install the stdlib-shims compatibility package (OCaml >= 4.07)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/stdlib-shims
	cp debian/META.stdlib-shims debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/stdlib-shims/META
# Install the bigarray compatibility package (OCaml >= 5.2)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bigarray
	cp debian/META.bigarray debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bigarray/META
# Install the bytes compatibility package (OCaml >= 5.2)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bytes
	cp debian/META.bytes debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bytes/META
# Remaining stuff
	touch $@

install-stamp:
# Install OCaml
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
# Remove config.cmx so that it is not part of compiler-libs ABI
	rm -f debian/tmp$(OCAML_STDLIB_DIR)/compiler-libs/config.cmx
ifeq (,$(DEB_TEST_BUILD_PREFIX))
# Remove Debian-specific file
	rm -f debian/tmp$(OCAML_STDLIB_DIR)/ld.conf
# Remove uninstalled files
	rm -f \
	  $(INSTDIR)/share/man/man1/ocamlopt.opt.1 \
	  $(INSTDIR)/share/man/man1/ocamlc.opt.1
ifeq ($(OCAML_HAVE_OCAMLOPT),no)
# Remove files that make no sense without ocamlopt
	rm -f \
	  $(INSTDIR)/share/man/man1/ocamloptp.1 \
	  $(INSTDIR)/share/man/man1/ocamlopt.1 \
	  $(INSTDIR)/bin/ocamloptp.* \
	  $(INSTDIR)/bin/ocamloptp
endif

## ocaml dbus-0.07

=== Makefile ===
DBUS_CFLAGS = -ccopt "$(shell pkg-config --cflags dbus-1)"
OCAMLC = ocamlc
OCAMLOPT = ocamlopt

DBUS_LDFLAGS = -cclib "" $(shell pkg-config --libs dbus-1)

OCAMLOPTFLAGS =
OCAML_PKG_NAME = dbus

OCAMLABI := $(shell ocamlc -version)
OCAMLLIBDIR := $(shell ocamlc -where)
OCAMLDESTDIR ?= $(OCAMLLIBDIR)

OCAML_TEST_INC = -I `ocamlfind query oUnit`
OCAML_TEST_LIB = `ocamlfind query oUnit`/oUnit.cmxa

CHECK_PKGS = dbus-1

INTERFACES = dBus.cmi dBus.mli
LIBS_NAT = dBus.cmxa
LIBS_BYTE = dBus.cma
LIBS = $(LIBS_BYTE) $(LIBS_NAT)
PROGRAMS = test

all: $(INTERFACES) $(LIBS_NAT) $(LIBS_BYTE)

all-opt: all

all-byte: $(INTERFACES) $(LIBS_BYTE)

bins: $(PROGRAMS)

libs: $(LIBS)

dBus.cmxa: libdbus_stubs.a dbus_stubs.a dBus.cmx
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -a -cclib -ldbus_stubs -cclib -ldbus-1 -o $@ dBus.cmx

dBus.cma: libdbus_stubs.a dBus.cmi dBus.cmo
	$(OCAMLC) -a -dllib dlldbus_stubs.so -cclib -ldbus_stubs -cclib -ldbus-1 -o $@ dBus.cmo

dbus_stubs.a: libdbus_stubs.a

libdbus_stubs.a: dbus_stubs.o
	ocamlmklib -o dbus_stubs $(DBUS_LDFLAGS) $+

%.cmo: %.ml
	$(OCAMLC) -c -o $@ $<

%.cmi: %.mli
	$(OCAMLC) -c -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c -o $@ $<

%.o: %.c
	$(OCAMLC) $(DBUS_CFLAGS) -c -o $@ $<

.PHONY: check
check:
	$(foreach pkg, $(CHECK_PKGS), \
		@pkg-config --modversion $(pkg) > /dev/null 2>&1 || \
			(echo "$(pkg) package not found" > /dev/stderr && exit 1))

.PHONY: install
install: $(LIBS)
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore $(OCAML_PKG_NAME) META $(INTERFACES) $(LIBS) *.a *.so *.cmx

install-opt: install

install-byte: all-byte
	ocamlfind install -destdir $(OCAMLDESTDIR) -ldconf ignore $(OCAML_PKG_NAME) META $(INTERFACES) $(LIBS_BYTE) *.a *.so

uninstall:
	ocamlfind remove -destdir $(OCAMLDESTDIR) $(OCAML_PKG_NAME)

test: dBus.cma test.ml
	$(OCAMLC) -o $@ unix.cma $+

clean:
	rm -f *.o *.so *.a *.cmo *.cmi *.cma *.cmx *.cmxa $(LIBS) $(PROGRAMS)
